//+------------------------------------------------------------------+
//|                                                mql5tuto02dva.mq5 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <Trade\AccountInfo.mqh>
#include <Trade\Trade.mqh>
#include <Charts\Chart.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   //MessageBox("OnInit");
   EventSetTimer(60);

   CAccountInfo ca;
   Print("Current Login = " + ca.Login());
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   //MessageBox("OnDeinit:reason=" + reason);
   //Alert("OnDeinit:reason=" + reason);
   Print("OnDeinit:reason)"+reason);
   EventKillTimer();
      
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
int currentTick = 0;
void OnTick()
  {
//---
      //MessageBox("OnTick");
      //Alert("OnTick");
      //Print("OnTick");
      //CChart cc;
      //Print(cc.Symbol());
                 
      CTrade trade;
      
      if (currentTick==0)
      {
         double currentbid = 0;
      
         MqlTick last_tick;
         if(SymbolInfoTick(Symbol(),last_tick))
         {
            Print(last_tick.time,": Bid = ",last_tick.bid, " Ask = ",last_tick.ask,"  Volume = ",last_tick.volume);
            currentbid = last_tick.bid;
            
            trade.Buy(0.1);
            Print("BUY DONE");
         }
         else Print("SymbolInfoTick() failed, error = ",GetLastError());
  
      }
      
      currentTick++;
      if (currentTick >= 10)
      {
         currentTick = 0;

         double tradeResultProfit = trade.CheckResultProfit();
         Print("Profit before SELL = ", tradeResultProfit);
                     
         trade.Sell(0.1);
         Print("SELL DONE");
         int tradeResultRetcode = trade.ResultRetcode();
         Print("tradeResultRetcode=" + tradeResultRetcode);
         if (tradeResultRetcode == TRADE_RETCODE_DONE)
         {
            Print("tradeResultRetcode = TRADE_RETCODE_DONE <=> OK");
            
         }
      }
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   Print("OnTimer");
  }
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction& trans,
                        const MqlTradeRequest& request,
                        const MqlTradeResult& result)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=0.0;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
//| TesterInit function                                              |
//+------------------------------------------------------------------+
void OnTesterInit()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterPass function                                              |
//+------------------------------------------------------------------+
void OnTesterPass()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterDeinit function                                            |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| BookEvent function                                               |
//+------------------------------------------------------------------+
void OnBookEvent(const string &symbol)
  {
//---
   
  }
//+------------------------------------------------------------------+
